/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago4q.ws;

import it.eng.spago.error.EMFUserError;
import it.eng.spago4q.extractors.AbstractExtractor;
import it.eng.spago4q.extractors.bo.GenericItem;
import it.eng.spago4q.extractors.bo.GenericItemInterface;

import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import javax.xml.rpc.ServiceException;

import org.apache.axis.message.MessageElement;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import com.microsoft.schemas.office.project.server.webservices.CustomFields.CustomFieldsLocator;
import com.microsoft.schemas.office.project.server.webservices.CustomFields.CustomFieldsSoap;
import com.microsoft.schemas.office.project.server.webservices.CustomFields.CustomFieldsSoapStub;
import com.microsoft.schemas.office.project.server.webservices.CustomFields.ReadCustomFieldsResponseReadCustomFieldsResult;
import com.microsoft.schemas.office.project.server.webservices.LoginForms.LoginFormsLocator;
import com.microsoft.schemas.office.project.server.webservices.LoginForms.LoginFormsSoap;
import com.microsoft.schemas.office.project.server.webservices.LoginForms.LoginFormsSoapStub;
import com.microsoft.schemas.office.project.server.webservices.Project.DataStoreEnum;
import com.microsoft.schemas.office.project.server.webservices.Project.ProjectLocator;
import com.microsoft.schemas.office.project.server.webservices.Project.ProjectSoap;
import com.microsoft.schemas.office.project.server.webservices.Project.ProjectSoapStub;
import com.microsoft.schemas.office.project.server.webservices.Project.ReadProjectListResponseReadProjectListResult;
import com.microsoft.schemas.office.project.server.webservices.Project.ReadProjectResponseReadProjectResult;



public class WSExtractor extends AbstractExtractor{

	public static String USER = "";
	public static String PASSWORD = "";
	public static String progetto_corrente = "";
	public static String metafase_corrente = "";
	public static ArrayList<String> useful;
	
	//parameter: 1-solo progetti; 2-progetto e metafasi; 3-tutto
	public static int parameter; 
	//Progetti da estrarre: "WorkingStore", "PublishedStore", "VersionsStore", "ReportingStore"
	public static String status;
	
	
	
	public List<GenericItemInterface> extract() throws EMFUserError {

		/** Parametri */
		String username = USER;
		String password = PASSWORD;	
		
		String[] use = {"PROJECT_NAME","METAFASE_NAME","METAFASE_CODE","PHASE_TYPE",
				"PROJ_UID","TASK_UID","TASK_NAME","TASK_IS_MILESTONE",
				"TASK_DUR","TASK_DUR_VAR","TASK_EAC","TASK_VAC",
				"TASK_ACT_DUR","TASK_REM_DUR","TASK_PCT_COMP","TASK_PCT_WORK_COMP",
				"TASK_WORK","TASK_ACT_WORK","TASK_REM_WORK","TASK_COST",
				"TASK_ACT_COST","TASK_REM_COST","TB_COST","TB_WORK",
				"TB_DUR","TASK_BCWS","TASK_BCWP","TASK_ACWP",
				"TASK_WBS","TASK_COST_VAR","TASK_CPI","TASK_CV",
				"TASK_SV","TASK_TCPI","TASK_WORK_VAR","TASK_START_VAR","TASK_START_DATE"};			
		useful = new ArrayList<String>(use.length);
		for (int i=0; i<use.length; i++) {
			useful.add(use[i]);
		}

		String cookie = loginFormsWS(username, password);
		
		return projWS(cookie, parameter, status);
	}

	
	/** LoginForms Web service to log on and log off users with Project Server authentication */
	public static String loginFormsWS(String user, String pw) {
		try {				
			LoginFormsLocator locator = new LoginFormsLocator();
			LoginFormsSoap loginSoap = locator.getLoginFormsSoap();
			LoginFormsSoapStub loginStub = (LoginFormsSoapStub)loginSoap;	
			locator.setMaintainSession(true);

			System.out.println("->Before Logging");
			boolean logged = loginStub.login(user, pw);	
			String[] TempCookie = (String[])loginStub._getCall().getMessageContext().getProperty("Cookie");	
			if (logged) {
				System.out.println("-->Login success");			
			}
			else
				System.out.println("-->Login failed");		


			String cookie = TempCookie[0];		
			return cookie;
		} catch (RemoteException e) {
			e.printStackTrace();
			return null;
		} catch (ServiceException a) {
			a.printStackTrace();
			return null;
		}
	}	

	/** Tramite projWS  possibile risalire ai progetti esistenti 
	 *  e a tutte le informazioni che contengono */
	public static List<GenericItemInterface> projWS (String cookie, int parameter, String status) {
		try {
			ProjectLocator proj = new ProjectLocator();
			ProjectSoap projSoap = proj.getProjectSoap();
			ProjectSoapStub projStub = (ProjectSoapStub)projSoap;		
			proj.setMaintainSession(true);
			projStub.setCookie(cookie);

			/** ArrayList di HashMap per contenere gli elementi di interesse del progetto */
			List<GenericItemInterface> array = new ArrayList<GenericItemInterface>();
			GenericItem map;

			/** Elenco dei progetti inseriti nel Server */			
			String[] projects = projectsList(projStub);

			/** Dati di ciascun progetto */
			for (int k=0; k<projects.length; k++) {				
				Element res = extractProject(projStub, projects[k], status);

				//Crea la mappa (id, nome) dei CustomFields dell'organizzazione
				HashMap<String,String> mapCustom = searchCustom(cookie);

				/** Custom Fields del progetto (estratti dal file di progetto)*/
				NodeList customList = res.getElementsByTagName("TaskCustomFields");
				//Mappa che conterr le triple <(Task_id, Custom_name), Custom_value>
				ArrayList<Chiave> allMap = new ArrayList<Chiave>();
				//Elenco di id dei custom_fields
				String[] custom = new String[customList.getLength()];
				String temp_id;
				for (int i=0; i<customList.getLength(); i++) {
					//...item(3)...  il tag del <MD_PROP_UID> 
					custom[i] = customList.item(i).getChildNodes().item(3).getChildNodes().item(0).getNodeValue();
					//...item(2)...  il tag del <TASK_UID> al quale  associato il custom
					temp_id = customList.item(i).getChildNodes().item(2).getChildNodes().item(0).getNodeValue();
					//Se il CustomField  presente tra quelli dell'organizzazione viene aggiunto come campo della tabella
					if (mapCustom.containsKey(custom[i])) {
						for (int j=0; j<customList.item(i).getChildNodes().getLength(); j++) {
							//Si estrae il valore del campo
							if(customList.item(i).getChildNodes().item(j).getNodeName().equalsIgnoreCase("TEXT_VALUE")) {							
								String tmp;
								if (customList.item(i).getChildNodes().item(j).getChildNodes().item(0) != null)
									tmp = customList.item(i).getChildNodes().item(j).getChildNodes().item(0).getNodeValue();							
								else
									tmp = "";
								Chiave key = new Chiave(temp_id, mapCustom.get(custom[i]), tmp);		
								allMap.add(key);
								break;
							}					
						}
					}
				}
				//Estrazione dei dati di interesse (evidenziati in giallo
				//nel foglio excel) e inserimento nella HashMap<String,Object> map
				NodeList list = res.getElementsByTagName("TASK_NAME");			
				for (int i=0; i<list.getLength(); i++) {
					Node nodo = list.item(i);
					if (parameter == 1) {
						if ((checkType(nodo)).equals("Progetto")) {						
							map = new GenericItem();
							populateMap(map, allMap, nodo);
							array.add(map);
							break;
						}
					}
					else if (parameter == 3) {
						map = new GenericItem();
						populateMap(map, allMap, nodo);
						array.add(map);
					}
					else if (!((checkType(nodo)).equals("Task"))) {
						map = new GenericItem();
						populateMap(map, allMap, nodo);
						array.add(map);
					}
				}
				System.out.println("---->Elements inserted into ArrayList");
			}
			return array;
			
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}

	/** WebService di accesso ai campi custom registrati nell'organizzazione */
	public static Element customFieldsWS(String cookie) throws Exception {
		CustomFieldsLocator csf = new CustomFieldsLocator();
		CustomFieldsSoap csfSoap = csf.getCustomFieldsSoap();
		CustomFieldsSoapStub csfStub = (CustomFieldsSoapStub)csfSoap;
		csf.setMaintainSession(true);
		csfStub.setCookie(cookie);		

		try {			
			ReadCustomFieldsResponseReadCustomFieldsResult tmp = csfStub.readCustomFields("",false);			
			MessageElement[] result = tmp.get_any();		
			Element res = result[1];			
			//				printFile("C:\\Test\\4\\Custom_fields.xml", result[1].getAsString());			
			return res;
		} catch (RemoteException a) {
			System.err.println(a);
			return null;			
		}
	}

	/** Estrae una lista dei progetti */
	public static String[] projectsList(ProjectSoapStub projStub) {
		try {
			ReadProjectListResponseReadProjectListResult temp = projStub.readProjectList();
			System.out.println("--->Project Web Service called");
			MessageElement[] result = temp.get_any();							
			Element res = result[1];

			//Estrae gli elementi che hanno come TagName "PROJ_UID" e quindi contengono 
			//gli ID dei progetti inseriti ne database del server
			NodeList list = res.getElementsByTagName("PROJ_UID");			
			String[] projects = new String[list.getLength()];
			for (int i=0; i<list.getLength(); i++) {
				projects[i] = list.item(i).getChildNodes().item(0).getNodeValue();
			}	
			return projects;

		} catch (RemoteException e) {
			e.printStackTrace();
			return null;
		}
	}

	/** Estrae i dati del progetto passato come parametro */
	public static Element extractProject(ProjectSoapStub projStub, String projectName, String status) {
		try {
			ReadProjectResponseReadProjectResult project_1 = projStub.readProject(projectName, DataStoreEnum.fromString(status));
			MessageElement[] result = project_1.get_any();							
			Element res = result[1];
			return res;
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}

	/** Riempie la HashMap corrente con gli elementi del task corrente */
	public static void populateMap(GenericItem map, ArrayList<Chiave> allMap, Node nodo) {
		NodeList list = nodo.getParentNode().getChildNodes();
		ArrayList<String> temporary = (ArrayList<String>)useful.clone();
		for (int i=0; i<list.getLength(); i++) {
			String tmp = list.item(i).getNodeName();			
			if (search(temporary, tmp)) {
				map.setValue(list.item(i).getNodeName(), list.item(i).getChildNodes().item(0).getNodeValue());
				temporary.remove(tmp);
			}
		}
		if (!temporary.isEmpty())
			for (int k=0; k<temporary.size(); k++) {
				map.setValue(temporary.get(k), null);
			}

		map.setValue("PHASE_TYPE", checkType(nodo));
		String sub = "null";
		if ((checkType(nodo)).equals("Progetto")) {
			progetto_corrente = nodo.getChildNodes().item(0).getNodeValue();
			metafase_corrente = nodo.getChildNodes().item(0).getNodeValue();
		}
		else if ((checkType(nodo)).equals("Metafase")) {
			metafase_corrente = nodo.getChildNodes().item(0).getNodeValue();
			String tmp = (String)map.getValue("TASK_NAME");
			if (tmp.indexOf("-") != -1)
				sub = tmp.substring(0, tmp.indexOf("-"));
			else
				sub = tmp.substring(0, tmp.indexOf(" "));
			map.setValue("Metafase_code", sub);
		}
		if (sub.equals("null"))
			map.setValue("Metafase_code", null);
		map.setValue("PROJECT_NAME", progetto_corrente);
		map.setValue("METAFASE_NAME", metafase_corrente);
		//Assegna al task i valori dei CustomFields che lo riguardano		
		for (int i=0; i<allMap.size(); i++) {
			if(map.getValue("TASK_UID").equalsIgnoreCase(allMap.get(i).getTid())) {
				map.setValue(allMap.get(i).getCname(), allMap.get(i).getCvalue());				
			}
		}		
	}

	/** Crea una HashMap contenente le coppie (id, nome) dei CustomFields registrati dall'organizzazione */
	public static HashMap<String, String> searchCustom(String cookie) {
		try {
			HashMap<String, String> map = new HashMap<String, String>();
			Element res = customFieldsWS(cookie);
			NodeList list = res.getElementsByTagName("MD_PROP_UID");
			String[] custom = new String[list.getLength()];
			for (int i=0; i<list.getLength(); i++) {
				custom[i] = list.item(i).getChildNodes().item(0).getNodeValue();
				NodeList tags = list.item(i).getParentNode().getChildNodes();
				for (int j=0; j<tags.getLength(); j++) {
					if (tags.item(j).getNodeName().equalsIgnoreCase("MD_PROP_NAME")) {
						String name = tags.item(j).getChildNodes().item(0).getNodeValue();						
						name = name.replace(" ", "_");
						name = name.replace("(Testo1)", "");
						if (name.charAt(name.length()-1) == '_')
							name = name.substring(0, name.length()-1);
						map.put(custom[i], name);				
						if (!useful.contains(name)) {							
							useful.add(name);
						}
						break;
					}					
				}
			}
			return map;
		} catch (Exception e) {			
			e.printStackTrace();
			return null;
		}
	}

	/** Cerca solo gli elementi di interesse tra tutti quelli presenti nella struttura */
	public static boolean search(ArrayList<String> use, String str) {
		for (int i=0; i<use.size(); i++) {
			if (use.get(i).equals(str))
				return true;
		}
		return false;
	}

	/** Controlla il tipo di elemento */
	public static String checkType(Node nodo) {
		//Controlla se  una metafase
		String phase_name = nodo.getChildNodes().item(0).toString();
		if (phase_name.startsWith("AA"))
			return "Metafase";
		else { 
			//Controlla se  il nodo radice
			NodeList figli = nodo.getParentNode().getChildNodes();
			String proj_id = figli.item(1).getChildNodes().item(0).getNodeValue();
			String parent_id = figli.item(2).getChildNodes().item(0).getNodeValue();		
			if (proj_id.equals(parent_id))
				return "Progetto";
			else
				//Altrimenti  un semplice Task
				return "Task";
		}
	}

	/** Oggetto chiave per mantenere le triple <(Task_id, CustomFieldName), CustomFieldValue> */
	static class Chiave {
		private String task_id;
		private String custom_name;
		private String custom_value;

		public Chiave() {
			this.task_id = "";
			this.custom_name = "";
			this.custom_value = "";
		}
		public Chiave(String t_id, String c_name, String c_v) {
			this.task_id = t_id;
			this.custom_name = c_name;
			this.custom_value = c_v;
		}

		public String getTid() {
			return this.task_id;
		}
		public String getCname() {
			return this.custom_name;
		}
		public String getCvalue() {
			return this.custom_value;
		}

		public String setTid(String t_id) {
			this.task_id = t_id;
			return this.task_id;
		}
		public String setCname(String c_name) {
			this.custom_name = c_name;
			return this.custom_name;
		}
		public String setCvalue(String c_v) {
			this.custom_value = c_v;
			return this.custom_value;
		}

		public boolean equals(Chiave key) {
			if (key.getTid().equalsIgnoreCase(this.task_id) && key.getCname().equalsIgnoreCase(this.custom_name) && key.getCvalue().equalsIgnoreCase(this.custom_value))
				return true;
			return false;
		}
		public String toString() {
			String toReturn = "T_id: " + task_id + " -- " + custom_name + ": " + custom_value;
			return toReturn;
		}
	}

	


	public String getStatus() {
		return status;
	}
	public void setStatus(String stat) {
		this.status = stat;
	}
	public int getParameter() {
		return parameter;
	}
	public void setParameter(int par) {
		this.parameter = par;
	}
	public String getUser() {
		return USER;
	}
	public void setUser(String user) {
		this.USER = user;
	}
	public String getPassword() {
		return PASSWORD;
	}
	public void setPassword(String password) {
		this.PASSWORD = password;
	}


	
	@Override
	protected void setUp() {
		USER =  readDataSourceParameterValue("USER");
		PASSWORD =  readDataSourceParameterValue("PASSWORD");
		parameter = Integer.parseInt(readDataSourceParameterValue("GRANULARITY"));
		status = readDataSourceParameterValue("PROJECT_STATUS");
	}


	@Override
	protected void tearDown() {
		// TODO Auto-generated method stub
		
	}
}




